<template>
  <div>
    <div class="app-container">
      <el-form
        :model="queryParams"
        ref="queryRef"
        :inline="true"
        v-show="showSearch"
        label-width="68px"
      >
        <el-form-item label="分类名称" prop="name">
          <el-input
            v-model="queryParams.name"
            placeholder="请输入分类名称"
            clearable
            @keyup.enter="handleQuery"
          />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="Search" @click="handleQuery"
            >搜索</el-button
          >
          <el-button icon="RefreshRight" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>

      <!-- <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button
            type="primary"
            plain
            icon="Plus"
            @click="handleAdd"
            v-hasPermi="['aleave:catagory:add']"
            >新增
          </el-button>
        </el-col>

        <right-toolbar
          v-model:showSearch="showSearch"
          @queryTable="getList"
        ></right-toolbar>
      </el-row> -->

      <el-table
        v-loading="loading"
        :data="catagoryList"
        @selection-change="handleSelectionChange"
      >
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="id" align="center" v-if="false" prop="id" />
        <el-table-column label="序号" width="55" type="index" />
        <el-table-column label="分类名称" align="center" prop="name" />
        <el-table-column label="创建时间" align="center" prop="createTime">
        </el-table-column>
        <el-table-column
          label="操作"
          align="center"
          class-name="small-padding fixed-width"
        >
          <template #default="scope">
            <el-button
              link
              type="primary"
              icon="Edit"
              @click="handleUpdate(scope.row)"
              v-hasPermi="['aleave:catagory:edit']"
              >编辑
            </el-button>
            <!-- <el-button
              link
              type="primary"
              icon="Delete"
              @click="handleDelete(scope.row)"
              v-hasPermi="['aleave:catagory:remove']"
              >删除
            </el-button> -->
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="total > 0"
        :total="total"
        v-model:page="queryParams.pageNum"
        v-model:limit="queryParams.pageSize"
        @pagination="getList"
      />

      <!-- 添加或修改A级权力分类对话框 -->
      <el-dialog :title="title" v-model="open" width="700px" append-to-body>
        <el-form
          ref="catagoryRef"
          :model="form"
          :rules="rules"
          label-width="80px"
        >
          <el-form-item label="分类名称" prop="name">
            <el-input v-model="form.name" placeholder="请输入分类名称" />
          </el-form-item>
          <el-form-item label="事项名称" prop="title">
            <el-input v-model="form.title" placeholder="请输入事项名称" />
          </el-form-item>
          <!-- <el-form-item label="添加部门" prop="deptname">
            <el-input v-model="form.deptname" placeholder="请输入添加部门" />
          </el-form-item> -->
          <el-divider content-position="center">A级权力节点信息</el-divider>
          <el-row :gutter="10" class="mb8">
            <el-col :span="1.5">
              <el-button
                type="primary"
                icon="Plus"
                @click="handleAddOaAleaveNode"
                >添加</el-button
              >
            </el-col>
            <el-col :span="1.5">
              <el-button
                type="danger"
                icon="Delete"
                @click="handleDeleteOaAleaveNode"
                >删除</el-button
              >
            </el-col>
          </el-row>
          <el-table
            :data="oaAleaveNodeList"
            :row-class-name="rowOaAleaveNodeIndex"
            @selection-change="handleOaAleaveNodeSelectionChange"
            ref="oaAleaveNode"
          >
            <el-table-column type="selection" width="50" align="center" />
            <el-table-column
              label="序号"
              align="center"
              prop="index"
              width="50"
            />
            <!--          <el-table-column label="节点名称" prop="nodeId" width="150">-->
            <!--            <template #default="scope">-->
            <!--              <el-input v-model="scope.row.nodeId" placeholder="请输入节点名称"/>-->
            <!--            </template>-->
            <!--          </el-table-column>-->
            <el-table-column label="节点名称" prop="nodeName" width="250">
              <template #default="scope">
                <el-input
                  v-model="scope.row.nodeName"
                  placeholder="请输入节点名称"
                />
              </template>
            </el-table-column>
            <el-table-column label="排序" prop="sort" width="250">
              <template #default="scope">
                <el-input v-model="scope.row.sort" placeholder="请输入排序" />
              </template>
            </el-table-column>
          </el-table>
        </el-form>
        <template #footer>
          <div style="margin-right: 20px" class="dialog-footer">
            <el-button type="primary" @click="submitForm">确 定</el-button>
            <el-button @click="cancel">取 消</el-button>
          </div>
        </template>
      </el-dialog>
    </div>
  </div>
</template>

<script setup name="Catagory">
import {
  listCatagory,
  getCatagory,
  delCatagory,
  addCatagory,
  updateCatagory,
} from "@/api/aleave/catagory";

const { proxy } = getCurrentInstance();

const catagoryList = ref([]);
const oaAleaveNodeList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const checkedOaAleaveNode = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    name: null,
  },
  rules: {},
});

const { queryParams, form, rules } = toRefs(data);

/** 查询A级权力分类列表 */
function getList() {
  loading.value = true;
  listCatagory(queryParams.value).then((response) => {
    catagoryList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    name: null,
    title: null,
    deptname: null,
    createBy: null,
    createTime: null,
    updateTime: null,
    updateBy: null,
  };
  oaAleaveNodeList.value = [];
  proxy.resetForm("catagoryRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加A级权力分类";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _id = row.id || ids.value;
  getCatagory(_id).then((response) => {
    form.value = response.data;
    oaAleaveNodeList.value = response.data.oaAleaveNodeList;
    open.value = true;
    title.value = "修改A级权力分类";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["catagoryRef"].validate((valid) => {
    if (valid) {
      form.value.oaAleaveNodeList = oaAleaveNodeList.value;
      if (form.value.id != null) {
        updateCatagory(form.value).then((response) => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addCatagory(form.value).then((response) => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value;
  proxy.$modal
    .confirm('是否确认删除A级权力分类编号为"' + _ids + '"的数据项？')
    .then(function () {
      return delCatagory(_ids);
    })
    .then(() => {
      getList();
      proxy.$modal.msgSuccess("删除成功");
    })
    .catch(() => {});
}

/** A级权力节点序号 */
function rowOaAleaveNodeIndex({ row, rowIndex }) {
  row.index = rowIndex + 1;
}

/** A级权力节点添加按钮操作 */
function handleAddOaAleaveNode() {
  let obj = {};
  obj.nodeId = "";
  obj.nodeName = "";
  obj.sort = "";
  oaAleaveNodeList.value.push(obj);
}

/** A级权力节点删除按钮操作 */
function handleDeleteOaAleaveNode() {
  if (checkedOaAleaveNode.value.length == 0) {
    proxy.$modal.msgError("请先选择要删除的A级权力节点数据");
  } else {
    const oaAleaveNodes = oaAleaveNodeList.value;
    const checkedOaAleaveNodes = checkedOaAleaveNode.value;
    oaAleaveNodeList.value = oaAleaveNodes.filter(function (item) {
      return checkedOaAleaveNodes.indexOf(item.index) == -1;
    });
  }
}

/** 复选框选中数据 */
function handleOaAleaveNodeSelectionChange(selection) {
  checkedOaAleaveNode.value = selection.map((item) => item.index);
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download(
    "aleave/catagory/export",
    {
      ...queryParams.value,
    },
    `catagory_${new Date().getTime()}.xlsx`
  );
}

getList();
</script>
